Index: /trunk/sources/HeuristicLab.SA/SA.cs
===================================================================
--- /trunk/sources/HeuristicLab.SA/SA.cs	(revision 1352)
+++ /trunk/sources/HeuristicLab.SA/SA.cs	(revision 1353)
@@ -130,4 +130,5 @@
       vi.AddVariable(new Variable("MaximumIterations", new IntData(1000)));
       vi.AddVariable(new Variable("Temperature", new DoubleData(100)));
+      vi.AddVariable(new Variable("MinimumTemperature", new DoubleData(0)));
       vi.AddVariable(new Variable("AnnealingParameter", new DoubleData(0.95)));
       vi.AddVariable(new Variable("SuccessRatioLimit", new DoubleData(1)));
@@ -278,8 +279,7 @@
 
       GreaterThanComparator gtc = new GreaterThanComparator();
-      gtc.Name = "Temperature > 0";
+      gtc.Name = "Temperature > MinimumTemperature";
       gtc.GetVariableInfo("LeftSide").ActualName = "Temperature";
-      gtc.GetVariableInfo("RightSide").Local = true;
-      gtc.AddVariable(new Variable("RightSide", new DoubleData(0)));
+      gtc.GetVariableInfo("RightSide").ActualName = "MinimumTemperature";
       gtc.GetVariableInfo("Result").ActualName = "TemperatureCondition";
       op.OperatorGraph.AddOperator(gtc);
@@ -404,4 +404,12 @@
       get { return myTemperature.Data; }
       set { myTemperature.Data = value; }
+    }
+    private DoubleData myMinimumTemperature;
+    /// <summary>
+    /// Gets or sets the minimum temperature.
+    /// </summary>
+    public double MinimumTemperature {
+      get { return myMinimumTemperature.Data; }
+      set { myMinimumTemperature.Data = value; }
     }
     private DoubleData myAnnealingParameter;
@@ -547,4 +555,5 @@
       myMaximumIterationEffort = vi.GetVariable("MaximumIterationEffort").GetValue<DoubleData>();
       myTemperature = vi.GetVariable("Temperature").GetValue<DoubleData>();
+      myMinimumTemperature = vi.GetVariable("MinimumTemperature").GetValue<DoubleData>();
       myAnnealingParameter = vi.GetVariable("AnnealingParameter").GetValue<DoubleData>();
       // Population Initialization
Index: /trunk/sources/HeuristicLab.SA/SAEditor.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.SA/SAEditor.Designer.cs	(revision 1352)
+++ /trunk/sources/HeuristicLab.SA/SAEditor.Designer.cs	(revision 1353)
@@ -49,4 +49,6 @@
       this.tabControl = new System.Windows.Forms.TabControl();
       this.parametersTabPage = new System.Windows.Forms.TabPage();
+      this.annealingParameterTextBox = new System.Windows.Forms.TextBox();
+      this.annealingParameterLabel = new System.Windows.Forms.Label();
       this.setEvaluationButton = new System.Windows.Forms.Button();
       this.setMutationButton = new System.Windows.Forms.Button();
@@ -84,6 +86,6 @@
       this.resetButton = new System.Windows.Forms.Button();
       this.cloneEngineButton = new System.Windows.Forms.Button();
-      this.annealingParameterTextBox = new System.Windows.Forms.TextBox();
-      this.annealingParameterLabel = new System.Windows.Forms.Label();
+      this.minimumTemperatureTextBox = new System.Windows.Forms.TextBox();
+      this.minimumTemperatureLabel = new System.Windows.Forms.Label();
       this.tabControl.SuspendLayout();
       this.parametersTabPage.SuspendLayout();
@@ -94,5 +96,5 @@
       // 
       this.executeButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.executeButton.Location = new System.Drawing.Point(0, 370);
+      this.executeButton.Location = new System.Drawing.Point(0, 397);
       this.executeButton.Name = "executeButton";
       this.executeButton.Size = new System.Drawing.Size(75, 23);
@@ -112,9 +114,11 @@
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(473, 364);
+      this.tabControl.Size = new System.Drawing.Size(473, 391);
       this.tabControl.TabIndex = 0;
       // 
       // parametersTabPage
       // 
+      this.parametersTabPage.Controls.Add(this.minimumTemperatureTextBox);
+      this.parametersTabPage.Controls.Add(this.minimumTemperatureLabel);
       this.parametersTabPage.Controls.Add(this.annealingParameterTextBox);
       this.parametersTabPage.Controls.Add(this.annealingParameterLabel);
@@ -152,13 +156,31 @@
       this.parametersTabPage.Name = "parametersTabPage";
       this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.parametersTabPage.Size = new System.Drawing.Size(465, 338);
+      this.parametersTabPage.Size = new System.Drawing.Size(465, 365);
       this.parametersTabPage.TabIndex = 0;
       this.parametersTabPage.Text = "Parameters";
       this.parametersTabPage.UseVisualStyleBackColor = true;
       // 
+      // annealingParameterTextBox
+      // 
+      this.annealingParameterTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.annealingParameterTextBox.Location = new System.Drawing.Point(159, 178);
+      this.annealingParameterTextBox.Name = "annealingParameterTextBox";
+      this.annealingParameterTextBox.Size = new System.Drawing.Size(186, 20);
+      this.annealingParameterTextBox.TabIndex = 31;
+      // 
+      // annealingParameterLabel
+      // 
+      this.annealingParameterLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.annealingParameterLabel.AutoSize = true;
+      this.annealingParameterLabel.Location = new System.Drawing.Point(6, 181);
+      this.annealingParameterLabel.Name = "annealingParameterLabel";
+      this.annealingParameterLabel.Size = new System.Drawing.Size(108, 13);
+      this.annealingParameterLabel.TabIndex = 30;
+      this.annealingParameterLabel.Text = "Annealing Parameter:";
+      // 
       // setEvaluationButton
       // 
       this.setEvaluationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.setEvaluationButton.Location = new System.Drawing.Point(410, 303);
+      this.setEvaluationButton.Location = new System.Drawing.Point(410, 323);
       this.setEvaluationButton.Name = "setEvaluationButton";
       this.setEvaluationButton.Size = new System.Drawing.Size(43, 20);
@@ -171,5 +193,5 @@
       // 
       this.setMutationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.setMutationButton.Location = new System.Drawing.Point(410, 277);
+      this.setMutationButton.Location = new System.Drawing.Point(410, 297);
       this.setMutationButton.Name = "setMutationButton";
       this.setMutationButton.Size = new System.Drawing.Size(43, 20);
@@ -182,5 +204,5 @@
       // 
       this.setAnnealingSchemeButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.setAnnealingSchemeButton.Location = new System.Drawing.Point(410, 251);
+      this.setAnnealingSchemeButton.Location = new System.Drawing.Point(410, 271);
       this.setAnnealingSchemeButton.Name = "setAnnealingSchemeButton";
       this.setAnnealingSchemeButton.Size = new System.Drawing.Size(43, 20);
@@ -193,5 +215,5 @@
       // 
       this.setSolutionGenerationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.setSolutionGenerationButton.Location = new System.Drawing.Point(410, 225);
+      this.setSolutionGenerationButton.Location = new System.Drawing.Point(410, 245);
       this.setSolutionGenerationButton.Name = "setSolutionGenerationButton";
       this.setSolutionGenerationButton.Size = new System.Drawing.Size(43, 20);
@@ -204,5 +226,5 @@
       // 
       this.viewEvaluationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.viewEvaluationButton.Location = new System.Drawing.Point(351, 303);
+      this.viewEvaluationButton.Location = new System.Drawing.Point(351, 323);
       this.viewEvaluationButton.Name = "viewEvaluationButton";
       this.viewEvaluationButton.Size = new System.Drawing.Size(53, 20);
@@ -215,5 +237,5 @@
       // 
       this.viewMutationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.viewMutationButton.Location = new System.Drawing.Point(351, 277);
+      this.viewMutationButton.Location = new System.Drawing.Point(351, 297);
       this.viewMutationButton.Name = "viewMutationButton";
       this.viewMutationButton.Size = new System.Drawing.Size(53, 20);
@@ -226,5 +248,5 @@
       // 
       this.viewAnnealingSchemeButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.viewAnnealingSchemeButton.Location = new System.Drawing.Point(351, 251);
+      this.viewAnnealingSchemeButton.Location = new System.Drawing.Point(351, 271);
       this.viewAnnealingSchemeButton.Name = "viewAnnealingSchemeButton";
       this.viewAnnealingSchemeButton.Size = new System.Drawing.Size(53, 20);
@@ -237,5 +259,5 @@
       // 
       this.viewSolutionGenerationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.viewSolutionGenerationButton.Location = new System.Drawing.Point(351, 225);
+      this.viewSolutionGenerationButton.Location = new System.Drawing.Point(351, 245);
       this.viewSolutionGenerationButton.Name = "viewSolutionGenerationButton";
       this.viewSolutionGenerationButton.Size = new System.Drawing.Size(53, 20);
@@ -248,5 +270,5 @@
       // 
       this.viewProblemInitializationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.viewProblemInitializationButton.Location = new System.Drawing.Point(351, 199);
+      this.viewProblemInitializationButton.Location = new System.Drawing.Point(351, 219);
       this.viewProblemInitializationButton.Name = "viewProblemInitializationButton";
       this.viewProblemInitializationButton.Size = new System.Drawing.Size(53, 20);
@@ -259,5 +281,5 @@
       // 
       this.setProblemInitializationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.setProblemInitializationButton.Location = new System.Drawing.Point(410, 199);
+      this.setProblemInitializationButton.Location = new System.Drawing.Point(410, 219);
       this.setProblemInitializationButton.Name = "setProblemInitializationButton";
       this.setProblemInitializationButton.Size = new System.Drawing.Size(43, 20);
@@ -270,5 +292,5 @@
       // 
       this.evaluationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.evaluationTextBox.Location = new System.Drawing.Point(159, 303);
+      this.evaluationTextBox.Location = new System.Drawing.Point(159, 323);
       this.evaluationTextBox.Name = "evaluationTextBox";
       this.evaluationTextBox.ReadOnly = true;
@@ -279,5 +301,5 @@
       // 
       this.mutationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.mutationTextBox.Location = new System.Drawing.Point(159, 277);
+      this.mutationTextBox.Location = new System.Drawing.Point(159, 297);
       this.mutationTextBox.Name = "mutationTextBox";
       this.mutationTextBox.ReadOnly = true;
@@ -288,5 +310,5 @@
       // 
       this.annealingSchemaTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.annealingSchemaTextBox.Location = new System.Drawing.Point(159, 251);
+      this.annealingSchemaTextBox.Location = new System.Drawing.Point(159, 271);
       this.annealingSchemaTextBox.Name = "annealingSchemaTextBox";
       this.annealingSchemaTextBox.ReadOnly = true;
@@ -297,5 +319,5 @@
       // 
       this.solutionGenerationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.solutionGenerationTextBox.Location = new System.Drawing.Point(159, 225);
+      this.solutionGenerationTextBox.Location = new System.Drawing.Point(159, 245);
       this.solutionGenerationTextBox.Name = "solutionGenerationTextBox";
       this.solutionGenerationTextBox.ReadOnly = true;
@@ -306,5 +328,5 @@
       // 
       this.problemInitializationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.problemInitializationTextBox.Location = new System.Drawing.Point(159, 199);
+      this.problemInitializationTextBox.Location = new System.Drawing.Point(159, 219);
       this.problemInitializationTextBox.Name = "problemInitializationTextBox";
       this.problemInitializationTextBox.ReadOnly = true;
@@ -316,5 +338,5 @@
       this.setRandomSeedRandomlyCheckBox.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.setRandomSeedRandomlyCheckBox.AutoSize = true;
-      this.setRandomSeedRandomlyCheckBox.Location = new System.Drawing.Point(159, 21);
+      this.setRandomSeedRandomlyCheckBox.Location = new System.Drawing.Point(159, 15);
       this.setRandomSeedRandomlyCheckBox.Name = "setRandomSeedRandomlyCheckBox";
       this.setRandomSeedRandomlyCheckBox.Size = new System.Drawing.Size(15, 14);
@@ -326,5 +348,5 @@
       this.evaluationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.evaluationLabel.AutoSize = true;
-      this.evaluationLabel.Location = new System.Drawing.Point(6, 306);
+      this.evaluationLabel.Location = new System.Drawing.Point(6, 326);
       this.evaluationLabel.Name = "evaluationLabel";
       this.evaluationLabel.Size = new System.Drawing.Size(60, 13);
@@ -336,5 +358,5 @@
       this.mutationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.mutationLabel.AutoSize = true;
-      this.mutationLabel.Location = new System.Drawing.Point(6, 280);
+      this.mutationLabel.Location = new System.Drawing.Point(6, 300);
       this.mutationLabel.Name = "mutationLabel";
       this.mutationLabel.Size = new System.Drawing.Size(51, 13);
@@ -346,5 +368,5 @@
       this.annealingSchemaLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.annealingSchemaLabel.AutoSize = true;
-      this.annealingSchemaLabel.Location = new System.Drawing.Point(6, 254);
+      this.annealingSchemaLabel.Location = new System.Drawing.Point(6, 274);
       this.annealingSchemaLabel.Name = "annealingSchemaLabel";
       this.annealingSchemaLabel.Size = new System.Drawing.Size(99, 13);
@@ -356,5 +378,5 @@
       this.solutionGenerationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.solutionGenerationLabel.AutoSize = true;
-      this.solutionGenerationLabel.Location = new System.Drawing.Point(6, 228);
+      this.solutionGenerationLabel.Location = new System.Drawing.Point(6, 248);
       this.solutionGenerationLabel.Name = "solutionGenerationLabel";
       this.solutionGenerationLabel.Size = new System.Drawing.Size(103, 13);
@@ -366,5 +388,5 @@
       this.problemInitializationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.problemInitializationLabel.AutoSize = true;
-      this.problemInitializationLabel.Location = new System.Drawing.Point(6, 202);
+      this.problemInitializationLabel.Location = new System.Drawing.Point(6, 222);
       this.problemInitializationLabel.Name = "problemInitializationLabel";
       this.problemInitializationLabel.Size = new System.Drawing.Size(105, 13);
@@ -375,5 +397,5 @@
       // 
       this.temperatureTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.temperatureTextBox.Location = new System.Drawing.Point(159, 132);
+      this.temperatureTextBox.Location = new System.Drawing.Point(159, 126);
       this.temperatureTextBox.Name = "temperatureTextBox";
       this.temperatureTextBox.Size = new System.Drawing.Size(186, 20);
@@ -384,5 +406,5 @@
       this.temperatureLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.temperatureLabel.AutoSize = true;
-      this.temperatureLabel.Location = new System.Drawing.Point(6, 135);
+      this.temperatureLabel.Location = new System.Drawing.Point(6, 129);
       this.temperatureLabel.Name = "temperatureLabel";
       this.temperatureLabel.Size = new System.Drawing.Size(70, 13);
@@ -393,5 +415,5 @@
       // 
       this.maximumIterationEffortTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.maximumIterationEffortTextBox.Location = new System.Drawing.Point(159, 106);
+      this.maximumIterationEffortTextBox.Location = new System.Drawing.Point(159, 100);
       this.maximumIterationEffortTextBox.Name = "maximumIterationEffortTextBox";
       this.maximumIterationEffortTextBox.Size = new System.Drawing.Size(186, 20);
@@ -402,5 +424,5 @@
       this.maximumIterationEffortLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.maximumIterationEffortLabel.AutoSize = true;
-      this.maximumIterationEffortLabel.Location = new System.Drawing.Point(6, 109);
+      this.maximumIterationEffortLabel.Location = new System.Drawing.Point(6, 103);
       this.maximumIterationEffortLabel.Name = "maximumIterationEffortLabel";
       this.maximumIterationEffortLabel.Size = new System.Drawing.Size(141, 13);
@@ -411,5 +433,5 @@
       // 
       this.randomSeedTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.randomSeedTextBox.Location = new System.Drawing.Point(159, 41);
+      this.randomSeedTextBox.Location = new System.Drawing.Point(159, 35);
       this.randomSeedTextBox.Name = "randomSeedTextBox";
       this.randomSeedTextBox.Size = new System.Drawing.Size(186, 20);
@@ -419,5 +441,5 @@
       // 
       this.maximumIterationsTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.maximumIterationsTextBox.Location = new System.Drawing.Point(159, 80);
+      this.maximumIterationsTextBox.Location = new System.Drawing.Point(159, 74);
       this.maximumIterationsTextBox.Name = "maximumIterationsTextBox";
       this.maximumIterationsTextBox.Size = new System.Drawing.Size(186, 20);
@@ -428,5 +450,5 @@
       this.setRandomSeedRandomlyLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.setRandomSeedRandomlyLabel.AutoSize = true;
-      this.setRandomSeedRandomlyLabel.Location = new System.Drawing.Point(6, 21);
+      this.setRandomSeedRandomlyLabel.Location = new System.Drawing.Point(6, 15);
       this.setRandomSeedRandomlyLabel.Name = "setRandomSeedRandomlyLabel";
       this.setRandomSeedRandomlyLabel.Size = new System.Drawing.Size(147, 13);
@@ -438,5 +460,5 @@
       this.randomSeedLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.randomSeedLabel.AutoSize = true;
-      this.randomSeedLabel.Location = new System.Drawing.Point(6, 44);
+      this.randomSeedLabel.Location = new System.Drawing.Point(6, 38);
       this.randomSeedLabel.Name = "randomSeedLabel";
       this.randomSeedLabel.Size = new System.Drawing.Size(78, 13);
@@ -448,5 +470,5 @@
       this.maximumIterationsLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.maximumIterationsLabel.AutoSize = true;
-      this.maximumIterationsLabel.Location = new System.Drawing.Point(6, 83);
+      this.maximumIterationsLabel.Location = new System.Drawing.Point(6, 77);
       this.maximumIterationsLabel.Name = "maximumIterationsLabel";
       this.maximumIterationsLabel.Size = new System.Drawing.Size(100, 13);
@@ -460,5 +482,5 @@
       this.scopesTabPage.Name = "scopesTabPage";
       this.scopesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.scopesTabPage.Size = new System.Drawing.Size(518, 307);
+      this.scopesTabPage.Size = new System.Drawing.Size(465, 338);
       this.scopesTabPage.TabIndex = 2;
       this.scopesTabPage.Text = "Scopes";
@@ -472,5 +494,5 @@
       this.scopeView.Name = "scopeView";
       this.scopeView.Scope = null;
-      this.scopeView.Size = new System.Drawing.Size(512, 301);
+      this.scopeView.Size = new System.Drawing.Size(459, 332);
       this.scopeView.TabIndex = 0;
       // 
@@ -479,5 +501,5 @@
       this.abortButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.abortButton.Enabled = false;
-      this.abortButton.Location = new System.Drawing.Point(81, 370);
+      this.abortButton.Location = new System.Drawing.Point(81, 397);
       this.abortButton.Name = "abortButton";
       this.abortButton.Size = new System.Drawing.Size(75, 23);
@@ -490,5 +512,5 @@
       // 
       this.resetButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.resetButton.Location = new System.Drawing.Point(162, 370);
+      this.resetButton.Location = new System.Drawing.Point(162, 397);
       this.resetButton.Name = "resetButton";
       this.resetButton.Size = new System.Drawing.Size(75, 23);
@@ -501,5 +523,5 @@
       // 
       this.cloneEngineButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.cloneEngineButton.Location = new System.Drawing.Point(367, 370);
+      this.cloneEngineButton.Location = new System.Drawing.Point(367, 397);
       this.cloneEngineButton.Name = "cloneEngineButton";
       this.cloneEngineButton.Size = new System.Drawing.Size(106, 23);
@@ -509,21 +531,21 @@
       this.cloneEngineButton.Click += new System.EventHandler(this.cloneEngineButton_Click);
       // 
-      // annealingParameterTextBox
-      // 
-      this.annealingParameterTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.annealingParameterTextBox.Location = new System.Drawing.Point(159, 158);
-      this.annealingParameterTextBox.Name = "annealingParameterTextBox";
-      this.annealingParameterTextBox.Size = new System.Drawing.Size(186, 20);
-      this.annealingParameterTextBox.TabIndex = 31;
-      // 
-      // annealingParameterLabel
-      // 
-      this.annealingParameterLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.annealingParameterLabel.AutoSize = true;
-      this.annealingParameterLabel.Location = new System.Drawing.Point(6, 161);
-      this.annealingParameterLabel.Name = "annealingParameterLabel";
-      this.annealingParameterLabel.Size = new System.Drawing.Size(108, 13);
-      this.annealingParameterLabel.TabIndex = 30;
-      this.annealingParameterLabel.Text = "Annealing Parameter:";
+      // minimumTemperatureTextBox
+      // 
+      this.minimumTemperatureTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.minimumTemperatureTextBox.Location = new System.Drawing.Point(159, 152);
+      this.minimumTemperatureTextBox.Name = "minimumTemperatureTextBox";
+      this.minimumTemperatureTextBox.Size = new System.Drawing.Size(186, 20);
+      this.minimumTemperatureTextBox.TabIndex = 33;
+      // 
+      // minimumTemperatureLabel
+      // 
+      this.minimumTemperatureLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.minimumTemperatureLabel.AutoSize = true;
+      this.minimumTemperatureLabel.Location = new System.Drawing.Point(6, 155);
+      this.minimumTemperatureLabel.Name = "minimumTemperatureLabel";
+      this.minimumTemperatureLabel.Size = new System.Drawing.Size(114, 13);
+      this.minimumTemperatureLabel.TabIndex = 32;
+      this.minimumTemperatureLabel.Text = "Minimum Temperature:";
       // 
       // SAEditor
@@ -537,5 +559,5 @@
       this.Controls.Add(this.executeButton);
       this.Name = "SAEditor";
-      this.Size = new System.Drawing.Size(473, 393);
+      this.Size = new System.Drawing.Size(473, 420);
       this.tabControl.ResumeLayout(false);
       this.parametersTabPage.ResumeLayout(false);
@@ -588,4 +610,6 @@
     private System.Windows.Forms.TextBox annealingParameterTextBox;
     private System.Windows.Forms.Label annealingParameterLabel;
+    private System.Windows.Forms.TextBox minimumTemperatureTextBox;
+    private System.Windows.Forms.Label minimumTemperatureLabel;
   }
 }
Index: /trunk/sources/HeuristicLab.SA/SAEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.SA/SAEditor.cs	(revision 1352)
+++ /trunk/sources/HeuristicLab.SA/SAEditor.cs	(revision 1353)
@@ -108,4 +108,5 @@
       maximumIterationEffortTextBox.DataBindings.Add("Text", SA, "MaximumIterationEffort");
       temperatureTextBox.DataBindings.Add("Text", SA, "Temperature");
+      minimumTemperatureTextBox.DataBindings.Add("Text", SA, "MinimumTemperature");
       annealingParameterTextBox.DataBindings.Add("Text", SA, "AnnealingParameter");
     }