Index: /branches/New Persistence Exploration/Persistence/Persistence/XmlFormatter.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/XmlFormatter.cs	(revision 1358)
+++ /branches/New Persistence Exploration/Persistence/Persistence/XmlFormatter.cs	(revision 1359)
@@ -5,6 +5,16 @@
 
 namespace HeuristicLab.Persistence {
+
+  struct XmlStrings {
+    public const string PRIMITIVE = "PRIMITVE";
+    public const string COMPOSITE = "COMPOSITE";
+    public const string REFERENCE = "REFERENCE";
+    public const string NULL = "NULL";
+    public const string TYPECACHE = "TYPCACHE";
+    public const string TYPE = "TYPE";
+  }
+  
   public class XmlFormatter {
-
+    
     delegate string Formatter(ISerializationToken token);
 
@@ -60,5 +70,5 @@
         attributes.Add("id", beginToken.Id.ToString());                                           
       string result = Prefix +
-                      FormatNode("COMPOSITE", attributes, NodeType.Start) + "\n";
+                      FormatNode(XmlStrings.COMPOSITE, attributes, NodeType.Start) + "\n";
       depth += 1;
       return result;
@@ -67,5 +77,5 @@
     private string FormatEnd(ISerializationToken token) {      
       depth -= 1;
-      return Prefix + "</COMPOSITE>\n";
+      return Prefix + "</" + XmlStrings.COMPOSITE + ">\n";
     }
 
@@ -80,6 +90,6 @@
         attributes.Add("id", dataToken.Id.ToString());
       return Prefix +
-        FormatNode("PRIMITIVE", attributes, NodeType.Start) +
-        dataToken.SerialData + "</PRIMITIVE>\n";      
+        FormatNode(XmlStrings.PRIMITIVE, attributes, NodeType.Start) +
+        dataToken.SerialData + "</" + XmlStrings.PRIMITIVE + ">\n";      
     }
 
@@ -90,5 +100,5 @@
       if ( refToken.Name != null )
         attributes.Add("name", refToken.Name);
-      return Prefix + FormatNode("REFERENCE", attributes, NodeType.Inline) + "\n";  
+      return Prefix + FormatNode(XmlStrings.REFERENCE, attributes, NodeType.Inline) + "\n";  
     }
 
@@ -98,14 +108,14 @@
       if (nullRefToken.Name != null)
         attributes.Add("name", nullRefToken.Name);
-      return Prefix + FormatNode("NULL", attributes, NodeType.Inline) + "\n";
+      return Prefix + FormatNode(XmlStrings.NULL, attributes, NodeType.Inline) + "\n";
     }
 
     public IEnumerable<string> Format(Dictionary<string, int> typeCache) {
-      yield return "<TYPECACHE>";
+      yield return "<" + XmlStrings.TYPECACHE + ">";
       foreach ( var pair in typeCache ) {
-        yield return String.Format("  <TYPE id=\"{0}\" name=\"{1}\"/>",
+        yield return String.Format("  <" + XmlStrings.TYPE + " id=\"{0}\" name=\"{1}\"/>",
                                    pair.Value, pair.Key);        
       }
-      yield return "</TYPECACHE>";
+      yield return "</" + XmlStrings.TYPECACHE + ">";
     }
   }
Index: /branches/New Persistence Exploration/Persistence/Persistence/XmlParser.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/XmlParser.cs	(revision 1358)
+++ /branches/New Persistence Exploration/Persistence/Persistence/XmlParser.cs	(revision 1359)
@@ -23,8 +23,8 @@
       reader = XmlReader.Create(input, settings);
       handlers = new Dictionary<string, Handler> {
-                     {"PRIMITIVE", ParsePrimitive},
-                     {"COMPOSITE", ParseComposite},
-                     {"REFERENCE", ParseReference},
-                     {"NULL", ParseNull}
+                     {XmlStrings.PRIMITIVE, ParsePrimitive},
+                     {XmlStrings.COMPOSITE, ParseComposite},
+                     {XmlStrings.REFERENCE, ParseReference},
+                     {XmlStrings.NULL, ParseNull}
                    };
     }
@@ -88,5 +88,5 @@
       XmlReader xmlReader = XmlReader.Create(reader);
       while ( xmlReader.Read() ) {
-        if (xmlReader.Name == "TYPE") {          
+        if (xmlReader.Name == XmlStrings.TYPE) {          
           typeCache.Add(xmlReader.GetAttribute("name")
           , int.Parse(xmlReader.GetAttribute("id")));