Index: /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1366)
+++ /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1367)
@@ -168,6 +168,6 @@
     /// </summary>
     #region PullJob
-    public event System.EventHandler<SendJobCompletedEventArgs> PullJobCompleted;
-    public void PullJobAsync(Guid guid) {
+    public event System.EventHandler<SendJobCompletedEventArgs> SendJobCompleted;
+    public void SendJobAsync(Guid guid) {
       if (ConnState == NetworkEnum.WcfConnState.Loggedin)        
         proxy.SendJobAsync(guid);
@@ -175,5 +175,5 @@
     void proxy_SendJobCompleted(object sender, SendJobCompletedEventArgs e) {
       if (e.Error == null)
-        PullJobCompleted(sender, e);
+        SendJobCompleted(sender, e);
       else
         NetworkErrorHandling(e.Error);
@@ -185,6 +185,6 @@
     /// </summary>
     #region SendJobResults
-    public event System.EventHandler<ProcessJobResultCompletedEventArgs> SendJobResultCompleted;
-    public void SendJobResultAsync(Guid clientId, long jobId, byte[] result, double percentage, Exception exception, bool finished) {
+    public event System.EventHandler<ProcessJobResultCompletedEventArgs> ProcessJobResultCompleted;
+    public void ProcessJobResultAsync(Guid clientId, long jobId, byte[] result, double percentage, Exception exception, bool finished) {
       if (ConnState == NetworkEnum.WcfConnState.Loggedin)
         proxy.ProcessJobResultAsync(clientId, jobId, result, percentage, exception, finished);
@@ -192,5 +192,5 @@
     private void proxy_ProcessJobResultCompleted(object sender, ProcessJobResultCompletedEventArgs e) {
       if (e.Error == null)
-        SendJobResultCompleted(sender, e);
+        ProcessJobResultCompleted(sender, e);
       else
         NetworkErrorHandling(e.Error);
@@ -223,6 +223,6 @@
     /// </summary>
     #region SendJobResults
-    public event System.EventHandler<ProcessJobResultCompletedEventArgs> SendStoredJobResultCompleted;
-    public void SendStoredJobResultAsync(Guid clientId, long jobId, byte[] result, double percentage, Exception exception, bool finished) {
+    public event System.EventHandler<ProcessJobResultCompletedEventArgs> ProcessStoredJobResultCompleted;
+    public void ProcessStoredJobResultAsync(Guid clientId, long jobId, byte[] result, double percentage, Exception exception, bool finished) {
       if (ConnState == NetworkEnum.WcfConnState.Loggedin)
         //TODO: some sort of algo for the stored jobs
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1366)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1367)
@@ -82,6 +82,6 @@
       wcfService = WcfService.Instance;
       wcfService.LoginCompleted += new EventHandler<LoginCompletedEventArgs>(wcfService_LoginCompleted);
-      wcfService.PullJobCompleted += new EventHandler<SendJobCompletedEventArgs>(wcfService_PullJobCompleted);
-      wcfService.SendJobResultCompleted += new EventHandler<ProcessJobResultCompletedEventArgs>(wcfService_SendJobResultCompleted);
+      wcfService.SendJobCompleted += new EventHandler<SendJobCompletedEventArgs>(wcfService_PullJobCompleted);
+      wcfService.ProcessJobResultCompleted += new EventHandler<ProcessJobResultCompletedEventArgs>(wcfService_SendJobResultCompleted);
       wcfService.ConnectionRestored += new EventHandler(wcfService_ConnectionRestored);
       wcfService.ServerChanged += new EventHandler(wcfService_ServerChanged);
@@ -136,5 +136,5 @@
         //Pull a Job from the Server
         case MessageContainer.MessageType.FetchJob: 
-          wcfService.PullJobAsync(ConfigManager.Instance.GetClientInfo().ClientId);
+          wcfService.SendJobAsync(ConfigManager.Instance.GetClientInfo().ClientId);
           break;          
         //A Job has finished and can be sent back to the server
@@ -160,5 +160,5 @@
 
       if (WcfService.Instance.ConnState == NetworkEnum.WcfConnState.Loggedin) {
-        wcfService.SendJobResultAsync(ConfigManager.Instance.GetClientInfo().ClientId,
+        wcfService.ProcessJobResultAsync(ConfigManager.Instance.GetClientInfo().ClientId,
           jId,
           sJob,
@@ -179,5 +179,5 @@
       long jId = (long)jobId;
       byte[] obj = engines[jId].GetSnapshot();
-      wcfService.SendJobResultAsync(ConfigManager.Instance.GetClientInfo().ClientId,
+      wcfService.ProcessJobResultAsync(ConfigManager.Instance.GetClientInfo().ClientId,
         jId,
         obj,