Index: /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 1370)
+++ /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 1371)
@@ -40,5 +40,14 @@
     /// </summary>
     /// <returns>the instance of the logger</returns>
-    public static Logging GetInstance() {
+    public static Logging Instance { 
+      get {
+        if (instance == null)
+         instance = new Logging();
+        return instance;
+      } 
+      set {}
+    } 
+    
+    static Logging GetInstance() {
       if (instance == null)
         instance = new Logging();
Index: /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1370)
+++ /trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1371)
@@ -93,7 +93,6 @@
           ConnectionRestored(this, new EventArgs());        
       }
-      catch (Exception ex) {
-        //Todo: Rename to HandleNetworkError
-        NetworkErrorHandling(ex);
+      catch (Exception ex) {      
+        HandleNetworkError(ex);
       }
     }
@@ -126,7 +125,7 @@
     /// </summary>
     /// <param name="e">The Exception</param>
-    private void NetworkErrorHandling(Exception e) {
+    private void HandleNetworkError(Exception e) {
       ConnState = NetworkEnum.WcfConnState.Failed;
-      Logging.GetInstance().Error(this.ToString(), "exception: ", e);
+      Logging.Instance.Error(this.ToString(), "exception: ", e);
     }
 
@@ -146,5 +145,5 @@
         LoginCompleted(sender, e);
       else
-        NetworkErrorHandling(e.Error.InnerException);
+        HandleNetworkError(e.Error.InnerException);
     }
 
@@ -154,9 +153,9 @@
           Response res = proxy.Login(clientInfo);
           ConnState = NetworkEnum.WcfConnState.Loggedin;
-          Logging.GetInstance().Info(this.ToString(), res.StatusMessage);
+          Logging.Instance.Info(this.ToString(), res.StatusMessage);
         }
       }
       catch (Exception e) {
-        NetworkErrorHandling(e);
+        HandleNetworkError(e);
       }
     }
@@ -177,5 +176,5 @@
         SendJobCompleted(sender, e);
       else
-        NetworkErrorHandling(e.Error);
+        HandleNetworkError(e.Error);
     }
     #endregion
@@ -194,5 +193,5 @@
         ProcessJobResultCompleted(sender, e);
       else
-        NetworkErrorHandling(e.Error);
+        HandleNetworkError(e.Error);
     }
 
@@ -214,5 +213,5 @@
         SendHeartBeatCompleted(sender, e);
       else
-        NetworkErrorHandling(e.Error);
+        HandleNetworkError(e.Error);
     }
 
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1370)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1371)
@@ -69,5 +69,5 @@
       abortRequested = false;
 
-      Logging.GetInstance().Info(this.ToString(), "Hive Client started");
+      Logging.Instance.Info(this.ToString(), "Hive Client started");
       ClientConsoleServer server = new ClientConsoleServer();
       server.StartClientConsoleServer(new Uri("net.tcp://127.0.0.1:8000/ClientConsole/"));
@@ -102,5 +102,5 @@
         MessageContainer container = queue.GetMessage();
         Debug.WriteLine("Main loop received this message: " + container.Message.ToString());
-        Logging.GetInstance().Info(this.ToString(), container.Message.ToString());
+        Logging.Instance.Info(this.ToString(), container.Message.ToString());
         DetermineAction(container);
       }
@@ -175,5 +175,5 @@
       }
       catch (InvalidStateException ise) {
-        Logging.GetInstance().Error(this.ToString(), "Exception: ", ise);
+        Logging.Instance.Error(this.ToString(), "Exception: ", ise);
       }
     }
@@ -197,7 +197,7 @@
     void wcfService_LoginCompleted(object sender, LoginCompletedEventArgs e) {
       if (e.Result.Success) {
-        Logging.GetInstance().Info(this.ToString(), "Login completed to Hive Server @ " + DateTime.Now);        
+        Logging.Instance.Info(this.ToString(), "Login completed to Hive Server @ " + DateTime.Now);        
       } else
-        Logging.GetInstance().Error(this.ToString(), e.Result.StatusMessage);
+        Logging.Instance.Error(this.ToString(), e.Result.StatusMessage);
     }    
 
@@ -236,5 +236,5 @@
           //better expand the sendjobresultcompltedeventargs with a boolean "snapshot?" flag
           if (e.Result.finished == false) {
-            Logging.GetInstance().Info(this.ToString(), "Snapshot for Job " + e.Result.JobId + " transmitted");
+            Logging.Instance.Info(this.ToString(), "Snapshot for Job " + e.Result.JobId + " transmitted");
           } else {
             AppDomain.Unload(appDomains[e.Result.JobId]);
@@ -246,7 +246,6 @@
           }
         }        
-      } else {
-        //Todo: don't Java Style! IT'S EVIL!
-        Logging.GetInstance().Error(this.ToString(), "Sending of job " + e.Result.JobId + " failed");
+      } else {        
+        Logging.Instance.Error(this.ToString(), "Sending of job " + e.Result.JobId + " failed");
       }
     }
@@ -254,5 +253,5 @@
     //Todo: First stop all threads, then terminate
     void wcfService_ServerChanged(object sender, EventArgs e) {
-      Logging.GetInstance().Info(this.ToString(), "ServerChanged has been called");
+      Logging.Instance.Info(this.ToString(), "ServerChanged has been called");
       lock (Locker) {
         foreach (KeyValuePair<long, AppDomain> entries in appDomains)
@@ -270,9 +269,9 @@
     //this is a little bit tricky - 
     void wcfService_ConnectionRestored(object sender, EventArgs e) {
-      Logging.GetInstance().Info(this.ToString(), "Reconnected to old server - checking currently running appdomains");                 
+      Logging.Instance.Info(this.ToString(), "Reconnected to old server - checking currently running appdomains");                 
 
       foreach (KeyValuePair<long, Executor> execKVP in engines) {
         if (!execKVP.Value.Running && execKVP.Value.CurrentMessage == MessageContainer.MessageType.NoMessage) {
-          Logging.GetInstance().Info(this.ToString(), "Checking for JobId: " + execKVP.Value.JobId);
+          Logging.Instance.Info(this.ToString(), "Checking for JobId: " + execKVP.Value.JobId);
           Thread finThread = new Thread(new ParameterizedThreadStart(GetFinishedJob));
           finThread.Start(execKVP.Value.JobId);
@@ -288,5 +287,5 @@
 
     void appDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e) {
-      Logging.GetInstance().Error(this.ToString(), " Exception: " + e.ExceptionObject.ToString());
+      Logging.Instance.Error(this.ToString(), " Exception: " + e.ExceptionObject.ToString());
     }
   }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/JobStorage/JobStorageManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/JobStorage/JobStorageManager.cs	(revision 1370)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/JobStorage/JobStorageManager.cs	(revision 1371)
@@ -28,9 +28,8 @@
         storedJobsList.Add(info);
         jobstream.Close();
-        Logging.GetInstance().Info("JobStorrageManager", "Job " + info.JobID + " stored on the harddisc");
+        Logging.Instance.Info("JobStorageManager", "Job " + info.JobID + " stored on the harddisc");
       }
       catch (Exception e) {
-        //Todo: Change to logging.exception!
-        Console.WriteLine(e);
+        Logging.Instance.Error("JobStorageManager", "Exception: ", e);
       }       
     }
@@ -40,5 +39,5 @@
         if (WcfService.Instance.ConnState == NetworkEnum.WcfConnState.Loggedin && (storedJobsList[index-1].ServerIP == WcfService.Instance.ServerIP && storedJobsList[index-1].ServerPort == WcfService.Instance.ServerPort)) {
           String filename = storedJobsList[index-1].ServerIP + "." + storedJobsList[index-1].ServerPort + "." + storedJobsList[index-1].JobID.ToString();
-          Logging.GetInstance().Info("JobStorrageManager", "Sending stored job " + storedJobsList[index-1].JobID + " to the server");
+          Logging.Instance.Info("JobStorrageManager", "Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
           byte[] job = File.ReadAllBytes(path + filename + ".dat");
           
@@ -47,5 +46,5 @@
           //TODO: has to be fixed from server side
           //if (res.Success == true) {
-          Logging.GetInstance().Info("JobStorrageManager", "Sending of job " + storedJobsList[index - 1].JobID + " done");  
+          Logging.Instance.Info("JobStorrageManager", "Sending of job " + storedJobsList[index - 1].JobID + " done");  
           storedJobsList.Remove(storedJobsList[index - 1]);
           File.Delete(path + filename + ".dat");