Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj	(revision 1373)
@@ -0,0 +1,76 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{A9E282EA-180F-4233-B809-AEDF0787545C}</ProjectGuid>
+    <OutputType>WinExe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Persistence.GUI</RootNamespace>
+    <AssemblyName>HeuristicLab.Persistence.GUI</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <StartupObject>HeuristicLab.Persistence.GUI.Program</StartupObject>
+    <TargetFrameworkSubset>Full</TargetFrameworkSubset>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <ItemGroup>
+    <ProjectReference Include="..\Persistence\HeuristicLab.Persistence.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="PersistenceConfigurationForm.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="PersistenceConfigurationForm.Designer.cs">
+      <DependentUpon>PersistenceConfigurationForm.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Program.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="PersistenceConfigurationForm.resx">
+      <DependentUpon>PersistenceConfigurationForm.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="app.config" />
+  </ItemGroup>
+</Project>
Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.Designer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.Designer.cs	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.Designer.cs	(revision 1373)
@@ -0,0 +1,101 @@
+﻿namespace HeuristicLab.Persistence.GUI {
+  partial class PersistenceConfigurationForm {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.Windows.Forms.ListViewItem listViewItem1 = new System.Windows.Forms.ListViewItem("Bli");
+      System.Windows.Forms.ListViewItem listViewItem2 = new System.Windows.Forms.ListViewItem("Bla");
+      System.Windows.Forms.ListViewItem listViewItem3 = new System.Windows.Forms.ListViewItem("Blo");
+      this.decomposerList = new System.Windows.Forms.ListView();
+      this.DecomposersColumn = new System.Windows.Forms.ColumnHeader();
+      this.checkbox = new System.Windows.Forms.CheckedListBox();
+      this.SuspendLayout();
+      // 
+      // decomposerList
+      // 
+      this.decomposerList.Activation = System.Windows.Forms.ItemActivation.OneClick;
+      this.decomposerList.AllowDrop = true;
+      this.decomposerList.CheckBoxes = true;
+      this.decomposerList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.DecomposersColumn});
+      this.decomposerList.FullRowSelect = true;
+      this.decomposerList.GridLines = true;
+      this.decomposerList.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
+      listViewItem1.Checked = true;
+      listViewItem1.StateImageIndex = 1;
+      listViewItem1.Tag = "";
+      listViewItem2.Checked = true;
+      listViewItem2.StateImageIndex = 1;
+      listViewItem3.Checked = true;
+      listViewItem3.StateImageIndex = 1;
+      this.decomposerList.Items.AddRange(new System.Windows.Forms.ListViewItem[] {
+            listViewItem1,
+            listViewItem2,
+            listViewItem3});
+      this.decomposerList.Location = new System.Drawing.Point(25, 12);
+      this.decomposerList.Name = "decomposerList";
+      this.decomposerList.ShowGroups = false;
+      this.decomposerList.Size = new System.Drawing.Size(194, 278);
+      this.decomposerList.TabIndex = 0;
+      this.decomposerList.UseCompatibleStateImageBehavior = false;
+      this.decomposerList.View = System.Windows.Forms.View.Details;
+      this.decomposerList.Resize += new System.EventHandler(this.decomposerList_Resize);
+      this.decomposerList.ItemChecked += new System.Windows.Forms.ItemCheckedEventHandler(this.decomposerList_ItemChecked);
+      this.decomposerList.DragDrop += new System.Windows.Forms.DragEventHandler(this.decomposerList_DragDrop);
+      this.decomposerList.DragEnter += new System.Windows.Forms.DragEventHandler(this.decomposerList_DragEnter);
+      this.decomposerList.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.decomposerList_ItemDrag);
+      // 
+      // DecomposersColumn
+      // 
+      this.DecomposersColumn.Text = "Decomposers";
+      this.DecomposersColumn.Width = 190;
+      // 
+      // checkbox
+      // 
+      this.checkbox.FormattingEnabled = true;
+      this.checkbox.Location = new System.Drawing.Point(314, 103);
+      this.checkbox.Name = "checkbox";
+      this.checkbox.Size = new System.Drawing.Size(180, 154);
+      this.checkbox.TabIndex = 1;
+      this.checkbox.ThreeDCheckBoxes = true;
+      // 
+      // PersistenceConfigurationForm
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(597, 580);
+      this.Controls.Add(this.checkbox);
+      this.Controls.Add(this.decomposerList);
+      this.Name = "PersistenceConfigurationForm";
+      this.Text = "PersistenceConfigurationForm";
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.ListView decomposerList;
+    private System.Windows.Forms.ColumnHeader DecomposersColumn;
+    private System.Windows.Forms.CheckedListBox checkbox;
+  }
+}
Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1373)
@@ -0,0 +1,96 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Persistence.Interfaces;
+
+namespace HeuristicLab.Persistence.GUI {
+  public partial class PersistenceConfigurationForm : Form {    
+    public PersistenceConfigurationForm() {
+      InitializeComponent();
+      decomposerList.Items.Clear();            
+      foreach ( IDecomposer decomposer in ConfigurationService.Instance.AllDecomposers ) {
+        var item = decomposerList.Items.Add(decomposer.GetType().Name);
+        item.Checked = true;
+        item.Tag = decomposer;
+      }      
+    }
+
+    private void decomposerList_ItemDrag(object sender, ItemDragEventArgs e) {
+      decomposerList.DoDragDrop(decomposerList.SelectedItems, DragDropEffects.Move);
+    }
+
+    private void decomposerList_DragEnter(object sender, DragEventArgs e) {      
+      if ( e.Data.GetDataPresent(typeof(ListView.SelectedListViewItemCollection).FullName)) {
+        e.Effect = DragDropEffects.Move;
+      } 
+    }
+
+    private void decomposerList_DragDrop(object sender, DragEventArgs e) {
+      if (decomposerList.SelectedItems.Count == 0) {
+        return;
+      }
+      //Returns the location of the mouse pointer in the ListView control.
+      Point cp = decomposerList.PointToClient(new Point(e.X, e.Y));
+      //Obtain the item that is located at the specified location of the mouse pointer.
+      ListViewItem dragToItem = decomposerList.GetItemAt(cp.X, cp.Y);
+      if (dragToItem == null) {
+        return;
+      }
+      //Obtain the index of the item at the mouse pointer.
+      int dragIndex = dragToItem.Index;
+      ListViewItem[] sel = new ListViewItem[decomposerList.SelectedItems.Count];
+      for (int i = 0; i <= decomposerList.SelectedItems.Count - 1; i++) {
+        sel[i] = decomposerList.SelectedItems[i];
+      }
+      for (int i = 0; i < sel.GetLength(0); i++) {
+        //Obtain the ListViewItem to be dragged to the target location.
+        ListViewItem dragItem = sel[i];
+        int itemIndex = dragIndex;
+        if (itemIndex == dragItem.Index) {
+          return;
+        }
+        if (dragItem.Index < itemIndex)
+          itemIndex++;
+        else
+          itemIndex = dragIndex + i;
+        //Insert the item at the mouse pointer.
+        ListViewItem insertItem = (ListViewItem) dragItem.Clone();
+        decomposerList.Items.Insert(itemIndex, insertItem);
+        //Removes the item from the initial location while 
+        //the item is moved to the new location.
+        decomposerList.Items.Remove(dragItem);
+      }
+      Update();
+    }
+
+    private void decomposerList_Resize(object sender, EventArgs e) {
+      DecomposersColumn.Width = decomposerList.Width - 4;
+    }
+
+    private IEnumerable<IDecomposer> GetDecomposers() {
+      List<IDecomposer> decomposers = new List<IDecomposer>();
+      foreach ( ListViewItem item in decomposerList.Items ) {
+        if (item != null && item.Checked)
+          decomposers.Add((IDecomposer) item.Tag);
+      }      
+      return decomposers;
+    }
+
+    private void Update() {
+      checkbox.Items.Clear();
+      foreach (var decomposer in GetDecomposers())
+        checkbox.Items.Add(decomposer.GetType().Name);      
+    }
+
+    private void decomposerList_ItemChecked(object sender, ItemCheckedEventArgs e) {
+      Update();
+    }
+
+  }
+}
Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.resx
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.resx	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.resx	(revision 1373)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/Program.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/Program.cs	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/Program.cs	(revision 1373)
@@ -0,0 +1,15 @@
+﻿using System;
+using System.Windows.Forms;
+using HeuristicLab.Persistence.GUI;
+
+namespace HeuristicLab.Persistence.GUI {
+
+  static class Program {    
+    [STAThread]
+    static void Main() {
+      Application.EnableVisualStyles();
+      Application.SetCompatibleTextRenderingDefault(false);
+      Application.Run(new PersistenceConfigurationForm());
+    }
+  }
+}
Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/app.config
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/app.config	(revision 1373)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/app.config	(revision 1373)
@@ -0,0 +1,3 @@
+﻿<?xml version="1.0"?>
+<configuration>
+<startup><supportedRuntime version="v2.0.50727"/></startup></configuration>
Index: branches/New Persistence Exploration/Persistence/Persistence.sln
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence.sln	(revision 1363)
+++ branches/New Persistence Exploration/Persistence/Persistence.sln	(revision 1373)
@@ -7,4 +7,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PluginInfrastructure", "..\..\..\trunk\sources\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj", "{94186A6A-5176-4402-AE83-886557B53CCA}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence.GUI", "HeuristicLab.Persistence.GUI\HeuristicLab.Persistence.GUI.csproj", "{A9E282EA-180F-4233-B809-AEDF0787545C}"
 EndProject
 Global
@@ -36,4 +38,10 @@
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.ActiveCfg = Release|x86
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.Build.0 = Release|x86
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|Any CPU.Build.0 = Release|Any CPU
+		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/New Persistence Exploration/Persistence/Persistence/Core/PersistenceConfiguration.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Core/PersistenceConfiguration.cs	(revision 1363)
+++ branches/New Persistence Exploration/Persistence/Persistence/Core/PersistenceConfiguration.cs	(revision 1373)
@@ -51,8 +51,20 @@
   public class ConfigurationService {
 
+    private static ConfigurationService instance;
     private readonly Dictionary<IFormat, List<IFormatter>> formatters;
     private readonly List<IDecomposer> decomposers;
+
+    public Dictionary<IFormat, List<IFormatter>> AllFormatters {
+      get {
+        return formatters;
+      }
+    }
+
+    public List<IDecomposer> AllDecomposers {
+      get {
+        return decomposers;
+      }
+    }
     
-    private static ConfigurationService instance;
     public static ConfigurationService Instance {
       get {